/**
  ******************************************************************************
  * @file    vk1650_driver.c
  * @author  kevin_guo
  * @version V1.0.0
  * @date    06-05-2018
  * @brief   This file provides IO i2c vk1650_driver functions.
  ******************************************************************************
  * @copy
  */ 
  
/* Includes ------------------------------------------------------------------*/	
#include "vk1650_driver.h"	

/* extern variables ----------------------------------------------------------*/
unsigned char write_buf[4];
unsigned char keyval;
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/
/*************************************************************
*ƣI2C_delay
*ܣʱuS
*
*
*    ע
**************************************************************/
void I2C_delay(__IO uint32_t nCount)
{
  uint32_t index = 0; 
  for(index = (10 * nCount); index != 0; index--)//200khz 10
  {
  }
}
/*************************************************************
*ƣI2C_delay
*ܣʱmS
*
*
*    ע
**************************************************************/
void VK1650_delayms(__IO uint32_t nCount)
{
  uint32_t i; 
  while(nCount--)
	{
		i = 10000; 
		while(i--);
	}
}
//GPIO ģI2C 
/*************************************************************
*ƣI2CStart
*ܣI2Cʼź
*
*
*    עʱ߸ʱɸߵ͵䣬ʾI2Cʼź
**************************************************************/
void I2CStart( void )
{
  VK1650_SCL_HIGH;
  VK1650_SDA_HIGH;
  I2C_delay(1);
  VK1650_SDA_LOW;
  I2C_delay(1);
}
/*************************************************************
*ƣI2CStop
*ܣI2Cֹͣź
*
*
*    עʱ߸ʱɵ͵ߵ䣬ʾI2Cֹͣź
**************************************************************/
void I2CStop( void )
{
  VK1650_SCL_LOW;
  VK1650_SDA_LOW;
  I2C_delay(1);
  VK1650_SCL_HIGH;
  I2C_delay(1);
  VK1650_SDA_LOW;
  I2C_delay(1);
  VK1650_SDA_HIGH;
  I2C_delay(1);
}
/*************************************************************
*ƣI2CSendAck
*ܣI2CӦ
*
*
*    ע
**************************************************************/
void I2CSendAck( void )
{  
  VK1650_SCL_LOW;
  VK1650_SDA_HIGH;
  I2C_delay(1);
  VK1650_SDA_LOW;
  I2C_delay(1);
  VK1650_SCL_HIGH;
  I2C_delay(1);
  VK1650_SDA_HIGH;
}
/*************************************************************
*ƣI2CSendNAck
*ܣI2CӦ
*
*
*    ע
**************************************************************/
void I2CSendNAck( void )
{  
  VK1650_SCL_LOW;
  VK1650_SDA_LOW;
  I2C_delay(1);
  VK1650_SDA_HIGH;
  I2C_delay(1);
  VK1650_SCL_HIGH;
  I2C_delay(1);
  VK1650_SDA_HIGH;
}
/*************************************************************
*ƣI2CSlaveAck
*ܣI2Cӻ豸Ӧѯ
*
*
*    ע
**************************************************************/
unsigned char I2CSlaveAck( void )
{
  unsigned int TimeOut;
  unsigned char RetValue;
  
  VK1650_SCL_LOW;
  I2C_delay(1);  
  VK1650_SCL_HIGH;
  TimeOut = 10000;
  while( TimeOut-- > 0 )
  {
    if( VK1650_SDA_IO==0 )
    {
      RetValue = 0;
      break;
    }
    else
    {
      RetValue = 1;
    }
  }
  return RetValue;
}
/*************************************************************
*ƣI2CWriteByte
*ܣI2Cдһֽ
*
*
*    ע
**************************************************************/
void I2CWriteByte( unsigned char byte )
{
  unsigned char i;

  for( i=0; i<8; i++ )
  {
    VK1650_SCL_LOW;
    if( 0X80 & byte )
      VK1650_SDA_HIGH;
    else
      VK1650_SDA_LOW;
    byte <<= 1;
    I2C_delay(1);

    VK1650_SCL_HIGH;
    I2C_delay(1);
  }
}

/*************************************************************
*ƣI2CReadByte
*ܣI2Cһֽ
*
*
*    ע
**************************************************************/
unsigned char I2CReadByte( void )
{
  unsigned char i;
  unsigned char ReadValue = 0;
  unsigned char bit;

	I2C_delay(2);
  for( i=0; i<8; i++ )
  {
		VK1650_SCL_LOW;
    I2C_delay(1);
    if( VK1650_SDA_IO==1 )
      bit = 0X01;
    else
      bit = 0x00;
      
    ReadValue = (ReadValue<<1)|bit;
		VK1650_SCL_HIGH;
    I2C_delay(1);
  }

  return ReadValue;
}

/*************************************************************
*: VK1650WriteCmd
*: I2C_IOVK1650дһֽ
*: cmd-д dat-
*0: д1:д
*    ע
**************************************************************/
unsigned char VK1650WriteCmd(unsigned char cmd,unsigned char dat)
{
	I2C_delay(100);//1mS Delay
  I2CStart();
	
  I2CWriteByte(cmd);
  if( 1 == I2CSlaveAck() )
  {
    return 1;
  }
  I2CWriteByte( dat );
  if( 1 == I2CSlaveAck() )
  {
    return 1;
  }
//	I2CSendAck();
//	I2CSendNAck();
  I2CStop();
 
  return 0;
}

/*************************************************************
*: VK1650ReadKey
*: I2C_IOVK16501ֽ
*: cmd   д
*
*    ע
**************************************************************/
unsigned char VK1650ReadKey(unsigned char cmd)
{	
	unsigned char result;
	I2C_delay(100);//1mS Delay
  I2CStart();

  I2CWriteByte(cmd);
  if( 1 == I2CSlaveAck() )
  {
    return 1;
  }
  result=I2CReadByte();
	I2CSendAck();
  I2CStop();
 
  return result;
}
/*******************************************************************************
* Function Name  : Vk1650_Init
* Description    : Vk1650ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Vk1650_Init(void)
{	
	GPIO_SetMode(VK1650_SCL_PORT, VK1650_SCL_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1650_SDA_PORT, VK1650_SDA_PIN, GPIO_MODE_QUASI);		//˫IO
	
	VK1650_SCL_HIGH;
	VK1650_SDA_HIGH; 	
}

/*******************************************************************************
* Function Name  : test_vk1640
* Description    : 1640Գ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
//    01
//  20  02
//    40
//  10  04
//    08    80
unsigned int num;
unsigned char num_tab[10]=
{//0    1     2    3    4    5    6    7   8   9
	0X3F,0X06,0X5B,0X4F,0X66,0X6D,0X7D,0X07,0X7F,0X6F
};
void VK1650_Main(void)
{   
	unsigned char i;
	
	Vk1650_Init();	 
	VK1650_delayms(100);  
	for(i=0;i<4;i++)
	{
		write_buf[i]=0xff;
	}
	VK1650WriteCmd(VK1650_DISP_GR1,write_buf[0]); 
	VK1650WriteCmd(VK1650_DISP_GR2,write_buf[1]); 
	VK1650WriteCmd(VK1650_DISP_GR3,write_buf[2]); 
	VK1650WriteCmd(VK1650_DISP_GR4,write_buf[3]); 
	VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP8SEG_ON|VK1650_LEVEL5); //Display on ,level8level8
	VK1650_delayms(2000); 
//	VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP_OFF); //Display off
//	VK1650_delayms(1000);
	while(1)
	{	
		for(i=0;i<4;i++)
		{
			write_buf[i]=0x00;
		}
		
		num++;
		if(num>9999)
			num=0;
		write_buf[0]=num_tab[num/1000];
		write_buf[1]=num_tab[num/100%10];
		write_buf[2]=num_tab[num/10%10];
		write_buf[3]=num_tab[num%10];
		VK1650WriteCmd(VK1650_DISP_GR1,write_buf[0]); 
		VK1650WriteCmd(VK1650_DISP_GR2,write_buf[1]); 
		VK1650WriteCmd(VK1650_DISP_GR3,write_buf[2]); 
		VK1650WriteCmd(VK1650_DISP_GR4,write_buf[3]); 
		VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP8SEG_ON|VK1650_LEVEL5); //Display on ,level8
		VK1650_delayms(10); 		
	
		keyval=VK1650ReadKey(VK1650_GETKEY);
		if(keyval==VK1650_KS1GR1)
		{
			for(i=0;i<4;i++)
			{
				write_buf[i]=0x01;
			}
			VK1650WriteCmd(VK1650_DISP_GR1,write_buf[0]); 
			VK1650WriteCmd(VK1650_DISP_GR2,write_buf[1]); 
			VK1650WriteCmd(VK1650_DISP_GR3,write_buf[2]); 
			VK1650WriteCmd(VK1650_DISP_GR4,write_buf[3]);
			VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP8SEG_ON|VK1650_LEVEL1); //Display on ,level1
			VK1650_delayms(1000);
		}
		if(keyval==VK1650_KS2GR1)
		{
			for(i=0;i<4;i++)
			{
				write_buf[i]=0x03;
			}
			VK1650WriteCmd(VK1650_DISP_GR1,write_buf[0]); 
			VK1650WriteCmd(VK1650_DISP_GR2,write_buf[1]); 
			VK1650WriteCmd(VK1650_DISP_GR3,write_buf[2]); 
			VK1650WriteCmd(VK1650_DISP_GR4,write_buf[3]);
			VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP8SEG_ON|VK1650_LEVEL2); //Display on ,level2
			VK1650_delayms(1000);
		}
		if(keyval==VK1650_KS3GR1)
		{
			for(i=0;i<4;i++)
			{
				write_buf[i]=0x07;
			}
			VK1650WriteCmd(VK1650_DISP_GR1,write_buf[0]); 
			VK1650WriteCmd(VK1650_DISP_GR2,write_buf[1]); 
			VK1650WriteCmd(VK1650_DISP_GR3,write_buf[2]); 
			VK1650WriteCmd(VK1650_DISP_GR4,write_buf[3]);
			VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP8SEG_ON|VK1650_LEVEL3); //Display on ,level3
			VK1650_delayms(1000);
		}
		if(keyval==VK1650_KS4GR1)
		{
			for(i=0;i<4;i++)
			{
				write_buf[i]=0x0f;
			}
			VK1650WriteCmd(VK1650_DISP_GR1,write_buf[0]); 
			VK1650WriteCmd(VK1650_DISP_GR2,write_buf[1]); 
			VK1650WriteCmd(VK1650_DISP_GR3,write_buf[2]); 
			VK1650WriteCmd(VK1650_DISP_GR4,write_buf[3]);
			VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP8SEG_ON|VK1650_LEVEL4); //Display on ,level4
			VK1650_delayms(1000);
		}
		if(keyval==VK1650_KS5GR1)
		{
			for(i=0;i<4;i++)
			{
				write_buf[i]=0x1f;
			}
			VK1650WriteCmd(VK1650_DISP_GR1,write_buf[0]); 
			VK1650WriteCmd(VK1650_DISP_GR2,write_buf[1]); 
			VK1650WriteCmd(VK1650_DISP_GR3,write_buf[2]); 
			VK1650WriteCmd(VK1650_DISP_GR4,write_buf[3]);
			VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP8SEG_ON|VK1650_LEVEL5); //Display on ,level5
			VK1650_delayms(1000);
		}
		if(keyval==VK1650_KS6GR1)
		{
			for(i=0;i<4;i++)
			{
				write_buf[i]=0x3f;
			}
			VK1650WriteCmd(VK1650_DISP_GR1,write_buf[0]); 
			VK1650WriteCmd(VK1650_DISP_GR2,write_buf[1]); 
			VK1650WriteCmd(VK1650_DISP_GR3,write_buf[2]); 
			VK1650WriteCmd(VK1650_DISP_GR4,write_buf[3]);
			VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP8SEG_ON|VK1650_LEVEL6); //Display on ,level6
			VK1650_delayms(1000);
		};
		if(keyval==VK1650_KS7GR1)
		{
			for(i=0;i<4;i++)
			{
				write_buf[i]=0x7f;
			}
			VK1650WriteCmd(VK1650_DISP_GR1,write_buf[0]); 
			VK1650WriteCmd(VK1650_DISP_GR2,write_buf[1]); 
			VK1650WriteCmd(VK1650_DISP_GR3,write_buf[2]); 
			VK1650WriteCmd(VK1650_DISP_GR4,write_buf[3]);
			VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP8SEG_ON|VK1650_LEVEL7); //Display on ,level7
			VK1650_delayms(1000);
		}
		if(keyval==VK1650_KS1GR4)
		{
			for(i=0;i<4;i++)
			{
				write_buf[i]=0xff;
			}
			VK1650WriteCmd(VK1650_DISP_GR1,write_buf[0]); 
			VK1650WriteCmd(VK1650_DISP_GR2,write_buf[1]); 
			VK1650WriteCmd(VK1650_DISP_GR3,write_buf[2]); 
			VK1650WriteCmd(VK1650_DISP_GR4,write_buf[3]);
			VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP8SEG_ON|VK1650_LEVEL5); //Display on ,level8
			VK1650_delayms(1000);
		}
		if(keyval==VK1650_KS2GR4)
		{
			VK1650WriteCmd(VK1650_CMD_SET,VK1650_DISP_OFF); //Display off
			VK1650_delayms(1000);
		}
//		VK1650WriteCmd(VK1650_CMD_SET,VK1650_SLEEP); //sleep
//		VK1650_delayms(1000);
	}
}   
/************************END OF FILE****/ 
