/**
  ******************************************************************************
  * @file    vk1650_driver.h
  * @author  kevin_guo
  * @version V1.0.0
  * @date    06-05-2018
  * @brief   Header files for IO i2c vk1650_driver. 
  ******************************************************************************
  * @copy
  */ 
  
#ifndef __VK1650_DRIVER_H__
#define __VK1650_DRIVER_H__

#include "M451Series.h"

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported define -----------------------------------------------------------*/
#define 	VK1650_SCL_PIN   BIT1
#define 	VK1650_SCL_PORT  PD
#define 	VK1650_SCL_IO    PD1

#define 	VK1650_SDA_PIN   BIT6
#define 	VK1650_SDA_PORT  PD
#define 	VK1650_SDA_IO    PD6

#define   VK1650_SCL_HIGH     VK1650_SCL_IO = 1  
#define   VK1650_SCL_LOW      VK1650_SCL_IO = 0  
  
#define   VK1650_SDA_HIGH     VK1650_SDA_IO = 1  
#define   VK1650_SDA_LOW      VK1650_SDA_IO = 0   
//
#define 	VK1650_CMD_SET      0x48  //
#define 	VK1650_DISP_OFF     0x00  //ʾ 
#define 	VK1650_DISP8SEG_ON	0x01  //8ʾ
#define 	VK1650_DISP7SEG_ON	0x09  //7ʾ
#define 	VK1650_SLEEP			  0x04  //
//ʾ
#define 	VK1650_DISP_GR1     0x68  //λ0ʾ
#define 	VK1650_DISP_GR2     0x6a  //λ1ʾ
#define 	VK1650_DISP_GR3     0x6c  //λ2ʾ
#define 	VK1650_DISP_GR4     0x6e  //λ3ʾ
//ȵȼ
#define 	VK1650_LEVEL1      	0x10  //1 
#define 	VK1650_LEVEL2      	0x20  //2 
#define 	VK1650_LEVEL3      	0x30  //3 
#define 	VK1650_LEVEL4      	0x40  //4 
#define 	VK1650_LEVEL5      	0x50  //5 
#define 	VK1650_LEVEL6      	0x60  //6 
#define 	VK1650_LEVEL7      	0x70  //7 
#define 	VK1650_LEVEL8      	0x00  //8 
//
#define 	VK1650_GETKEY      	0x4F  // ֧ϼ
//ֵ
#define 	VK1650_KS1GR1      	0x44 
#define 	VK1650_KS1GR2      	0x45 
#define 	VK1650_KS1GR3     	0x46 
#define 	VK1650_KS1GR4      	0x47 
#define 	VK1650_KS2GR1      	0x4C 
#define 	VK1650_KS2GR2      	0x4D 
#define 	VK1650_KS2GR3     	0x4E 
#define 	VK1650_KS2GR4      	0x4F 
 
#define 	VK1650_KS3GR1      	0x54 
#define 	VK1650_KS3GR2      	0x55 
#define 	VK1650_KS3GR3     	0x56 
#define 	VK1650_KS3GR4      	0x57 
#define 	VK1650_KS4GR1      	0x5C 
#define 	VK1650_KS4GR2      	0x5D 
#define 	VK1650_KS4GR3     	0x5E 
#define 	VK1650_KS4GR4      	0x5F 

#define 	VK1650_KS5GR1      	0x64 
#define 	VK1650_KS5GR2      	0x65 
#define 	VK1650_KS5GR3     	0x66 
#define 	VK1650_KS5GR4      	0x67 
#define 	VK1650_KS6GR1      	0x6C 
#define 	VK1650_KS6GR2      	0x6D 
#define 	VK1650_KS6GR3     	0x6E 
#define 	VK1650_KS6GR4      	0x6F 

#define 	VK1650_KS7GR1      	0x74 
#define 	VK1650_KS7GR2      	0x75 
#define 	VK1650_KS7GR3     	0x76 
#define 	VK1650_KS7GR4      	0x77  
/* Exported functions ------------------------------------------------------- */
void Vk1650_Init(void); 
unsigned char VK1650WriteCmd(unsigned char cmd,unsigned char dat);
unsigned char VK1650ReadKey(unsigned char cmd);

void VK1650_Main(void);
#endif  /*__VK1650_DRIVER_H__*/

/************************END OF FILE****/
